/*
 * This file is part of the Generic Data Structures Library (GDSL).
 * Copyright (C) 1998-2018 Nicolas Darnis <ndarnis@free.fr>.
 *
 * GDSL is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GDSL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GDSL.  If not, see <http://www.gnu.org/licenses/>. 
 *
 *
 * GDSL - Generic Data Structures Library
 * $RCSfile: _strings.h,v $
 * $Revision: 1.12 $
 * $Date: 2015/02/17 12:33:16 $
 */


#ifndef __MY_STRINGS_H_
#define __MY_STRINGS_H_


#include "gdsl_types.h"


extern gdsl_element_t 
alloc_string (void* string);

extern void 
free_string (gdsl_element_t e);

extern gdsl_element_t
copy_string (gdsl_element_t e);

extern void
print_string (gdsl_element_t e, FILE* file, gdsl_location_t location, void* d);

extern long int 
compare_strings (gdsl_element_t s1, void* s2);


#endif /* __MY_STRINGS_H_ */


/** EMACS **
 * Local variables:
 * mode: c
 * c-basic-offset: 4
 * End:
 */
